import java.util.*;

public class Floor
{
  Global global;
  Vector queue;
  int floor;
  int up_button,down_button; // 1=pressed, 0=cleared

  public Floor(Global g,int f)
  {
    global = g;
    floor = f;
    queue = new Vector();
    up_button = down_button = 0;
  }

  public void time_step()
  {
    // if (floor==1 && global.rand.nextFloat()<0.2) // higher lobby traffic
    if (global.rand.nextFloat()<0.02)
    {
      Passenger p=new Passenger(global,floor);
      queue.add(p);
      if (p.dest>floor) up_button = 1;
      if (p.dest<floor) down_button = 1;
    }
  }

  public void reset_button(int dir) // input dir: +1, -1
  {
    if (dir==1) up_button = 0;
    else if (dir==-1) down_button = 0;
  }

  public int pressed(int dir) // input dir: +1, -1; returns 1 or 0
  {
    if (dir==1) return up_button;
    else if (dir==-1) return down_button;
    else return -1;
  }

  void dequeue(Passenger p)
  {
    queue.remove(p);
  }

  public void check_buttons()
  {
    for (int i=0 ; i<queue.size() ; i++)
    {
      Passenger p=(Passenger)queue.elementAt(i);
      if (p.dest>floor) up_button = 1;
      if (p.dest<floor) down_button = 1;
    }
  }

  public void print()
  {
    System.out.format("floor %d: up=%d down=%d queue=%d: ",floor,up_button,down_button,queue.size());
    for (int i=0 ; i<queue.size() ; i++) { Passenger p=(Passenger)queue.elementAt(i); System.out.format("id=%d/dest=%d/wait=%d ",p.id,p.dest,p.wait_time()); }
    System.out.println();
  }
}
